unit testring0main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Ring0, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Timer1: TTimer;
    Label1: TLabel;
    Label2: TLabel;
    Button2: TButton;
    Label3: TLabel;
    Label4: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var   Form1 : TForm1;
      R     : TRing0;

const TSC   = $10;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  R := TRing0.Create(Self);

  // Open CMOS clock
  R.OpenPorts($70,$71);
end;

function CMOS(I:Integer) : String;
begin
  R.PortB[$70] := I;
  I            := R.PortB[$71];
  Result       := inttostr(10*(I shr 4) + I and $F); // BCD decode
  if Length(Result) < 2 then Result := '0'+Result;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Label1.Caption := inttostr(R.MSR[TSC]);
  Label4.Caption := CMOS(4)+':'+CMOS(2)+':'+CMOS(0);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  R.MSR[TSC] := 0;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  R.ClosePorts(0,$FFFF);
end;

end.
